blob: 9bfd0580b4d91572aa64e9c6b635601b1a69d580 [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
6# http://nvie.com/archives/323
7#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
11# Copyright (c) 2010 by Vincent Driessen
12# Copyright (c) 2010 by Benedikt Böhm
13#
14
Vincent Driessenab3dc492010-01-29 12:35:49 +010015VERSION_PREFIX=$(git config --get gitflow.prefix.versiontag)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010016PREFIX=$(git config --get gitflow.prefix.hotfix || echo hotfix/)
17
Benedikt Böhm00ccea62010-01-26 12:39:36 +010018usage() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010019 echo "usage: git flow hotfix [list] [-v]"
Vincent Driessen186d2b52010-01-27 23:48:39 +010020 echo " git flow hotfix start <version> [<base>]"
Vincent Driessen010252a2010-02-04 10:31:29 +010021 echo " git flow hotfix finish <version>"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010022}
23
Vincent Driessen186d2b52010-01-27 23:48:39 +010024cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010025 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010026}
27
Vincent Driessenb866b012010-01-28 01:01:53 +010028cmd_list() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010029 DEFINE_boolean verbose false 'verbose (more) output' v
30 parse_args "$@"
31
Vincent Driessenf46e2902010-02-15 23:01:52 +010032 local hotfix_branches
33 local current_branch
34 local short_names
Vincent Driessen21c7aa92010-02-16 20:57:35 +010035 hotfix_branches=$(echo "$(gitflow_local_branches)" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010036 if [ -z "$hotfix_branches" ]; then
Vincent Driessen186d2b52010-01-27 23:48:39 +010037 warn "No hotfix branches exist."
38 exit 0
39 fi
Vincent Driessen27592dd2010-02-06 14:45:39 +010040 current_branch=$(git branch | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
Vincent Driessen68845232010-02-10 00:43:21 +010041 short_names=$(echo "$hotfix_branches" | sed "s ^$PREFIX g")
Vincent Driessen3c337fb2010-02-04 11:30:18 +010042
Vincent Driessen3c337fb2010-02-04 11:30:18 +010043 # determine column width first
Vincent Driessenf46e2902010-02-15 23:01:52 +010044 local width=0
45 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010046 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010047 local len=${#branch}
Vincent Driessen3c337fb2010-02-04 11:30:18 +010048 width=$(max $width $len)
49 done
Vincent Driessenf46e2902010-02-15 23:01:52 +010050 width=$(($width+3))
Vincent Driessen3c337fb2010-02-04 11:30:18 +010051
Vincent Driessenf46e2902010-02-15 23:01:52 +010052 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010053 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010054 local fullname=$PREFIX$branch
55 local base=$(git merge-base "$fullname" "$MASTER_BRANCH")
56 local master_sha=$(git rev-parse "$MASTER_BRANCH")
57 local branch_sha=$(git rev-parse "$fullname")
Vincent Driessen27592dd2010-02-06 14:45:39 +010058 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +010059 printf "* "
60 else
61 printf " "
62 fi
63 if flag verbose; then
64 printf "%-${width}s" "$branch"
65 if [ "$branch_sha" = "$master_sha" ]; then
66 printf "(no commits yet)"
67 else
Vincent Driessenf46e2902010-02-15 23:01:52 +010068 local tagname=$(git name-rev --tags --no-undefined --name-only "$base")
69 local nicename
Vincent Driessen3c337fb2010-02-04 11:30:18 +010070 if [ "$tagname" != "" ]; then
Vincent Driessenc5fcc012010-02-10 00:18:08 +010071 nicename=$tagname
Vincent Driessen3c337fb2010-02-04 11:30:18 +010072 else
Vincent Driessena4dd2232010-02-10 00:34:59 +010073 nicename=$(git rev-parse --short "$base")
Vincent Driessen3c337fb2010-02-04 11:30:18 +010074 fi
75 printf "(based on $nicename)"
76 fi
77 else
78 printf "%s" "$branch"
79 fi
80 echo
81 done
Vincent Driessen186d2b52010-01-27 23:48:39 +010082}
83
Benedikt Böhm00ccea62010-01-26 12:39:36 +010084cmd_help() {
85 usage
86 exit 0
87}
88
Vincent Driessenb866b012010-01-28 01:01:53 +010089parse_args() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010090 # parse options
91 FLAGS "$@" || exit $?
92 eval set -- "${FLAGS_ARGV}"
93
94 # read arguments into global variables
Vincent Driessenc5fcc012010-02-10 00:18:08 +010095 VERSION=$1
Vincent Driessen3c337fb2010-02-04 11:30:18 +010096 BRANCH=$PREFIX$VERSION
97}
98
99require_version_arg() {
Vincent Driessenb866b012010-01-28 01:01:53 +0100100 if [ "$VERSION" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100101 warn "Missing argument <version>"
Vincent Driessenb866b012010-01-28 01:01:53 +0100102 usage
103 exit 1
104 fi
Vincent Driessenb866b012010-01-28 01:01:53 +0100105}
106
Vincent Driessen010252a2010-02-04 10:31:29 +0100107require_base_is_on_master() {
108 if ! git branch --contains "$BASE" 2>/dev/null \
109 | sed 's/[* ] //g' \
110 | grep -q "^$MASTER_BRANCH\$"; then
111 die "fatal: Given base '$BASE' is not a valid commit on '$MASTER_BRANCH'."
112 fi
113}
114
Vincent Driessen6d64d2c2010-02-16 06:41:13 +0100115require_no_existing_hotfix_branches() {
Vincent Driessen21c7aa92010-02-16 20:57:35 +0100116 local hotfix_branches=$(echo "$(gitflow_local_branches)" | grep "^$PREFIX")
Vincent Driessen6d64d2c2010-02-16 06:41:13 +0100117 local first_branch=$(echo ${hotfix_branches} | head -n1)
118 first_branch=${first_branch#$PREFIX}
119 [ -z "$hotfix_branches" ] || \
120 die "There is an existing hotfix branch ($first_branch). Finish that one first."
121}
122
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100123cmd_start() {
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100124 DEFINE_boolean fetch true "fetch from $ORIGIN before performing finish" F
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100125 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100126 BASE=${2:-$MASTER_BRANCH}
Vincent Driessen010252a2010-02-04 10:31:29 +0100127 require_version_arg
128 require_base_is_on_master
Vincent Driessen6d64d2c2010-02-16 06:41:13 +0100129 require_no_existing_hotfix_branches
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100130
131 # sanity checks
Vincent Driessen48386442010-01-29 10:30:40 +0100132 gitflow_require_clean_working_tree
Vincent Driessena4dd2232010-02-10 00:34:59 +0100133 gitflow_require_branch_absent "$BRANCH"
134 gitflow_require_tag_absent "$VERSION_PREFIX$VERSION"
Vincent Driessenca73caf2010-02-07 19:46:38 +0100135 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100136 git fetch -q "$ORIGIN" "$MASTER_BRANCH"
Vincent Driessen2acfffd2010-01-29 12:37:22 +0100137 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100138 gitflow_require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100139
140 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100141 git checkout -b "$BRANCH" "$BASE"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100142
143 echo
144 echo "Summary of actions:"
145 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
146 echo "- You are now on branch '$BRANCH'"
147 echo
148 echo "Follow-up actions:"
149 echo "- Bump the version number now!"
150 echo "- Start committing your hot fixes"
151 echo "- When done, run:"
152 echo
Vincent Driessen010252a2010-02-04 10:31:29 +0100153 echo " git flow hotfix finish '$VERSION'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100154 echo
155}
156
157cmd_finish() {
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100158 DEFINE_boolean fetch true "fetch from $ORIGIN before performing finish" F
159 DEFINE_boolean sign false "sign the release tag cryptographically" s
160 DEFINE_string signingkey "" "use the given GPG-key for the digital signature (implies -s)" u
161 DEFINE_string message "" "use the given tag message" m
Vincent Driessenddba2df2010-02-19 06:42:18 +0100162 DEFINE_boolean push false "push to $ORIGIN after performing finish" p
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100163 parse_args "$@"
Vincent Driessen010252a2010-02-04 10:31:29 +0100164 require_version_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100165
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100166 # handle flags that imply other flags
167 if [ "$FLAGS_signingkey" != "" ]; then
168 FLAGS_sign=$FLAGS_TRUE
169 fi
170
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100171 # sanity checks
Vincent Driessena4dd2232010-02-10 00:34:59 +0100172 gitflow_require_branch "$BRANCH"
Vincent Driessen48386442010-01-29 10:30:40 +0100173 gitflow_require_clean_working_tree
Vincent Driessenca73caf2010-02-07 19:46:38 +0100174 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100175 git fetch -q "$ORIGIN" "$MASTER_BRANCH" || \
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100176 die "Could not fetch $MASTER_BRANCH from $ORIGIN."
Vincent Driessena4dd2232010-02-10 00:34:59 +0100177 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH" || \
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100178 die "Could not fetch $DEVELOP_BRANCH from $ORIGIN."
Vincent Driessen2acfffd2010-01-29 12:37:22 +0100179 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100180 gitflow_require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH"
181 gitflow_require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100182
Vincent Driessen5fa47582010-02-09 00:31:33 +0100183 # try to merge into master
184 # in case a previous attempt to finish this release branch has failed,
185 # but the merge into master was successful, we skip it now
Vincent Driessena4dd2232010-02-10 00:34:59 +0100186 if ! gitflow_is_branch_merged_into "$BRANCH" "$MASTER_BRANCH"; then
187 git checkout "$MASTER_BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100188 die "Could not check out $MASTER_BRANCH."
Vincent Driessena4dd2232010-02-10 00:34:59 +0100189 git merge --no-ff "$BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100190 die "There were merge conflicts."
191 # TODO: What do we do now?
192 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100193
Vincent Driessen5fa47582010-02-09 00:31:33 +0100194 # try to tag the release
195 # in case a previous attempt to finish this release branch has failed,
196 # but the tag was set successful, we skip it now
Vincent Driessenf46e2902010-02-15 23:01:52 +0100197 local tagname=$VERSION_PREFIX$VERSION
Vincent Driessena4dd2232010-02-10 00:34:59 +0100198 if ! gitflow_tag_exists "$tagname"; then
Vincent Driessenf46e2902010-02-15 23:01:52 +0100199 local opts="-a"
Vincent Driessen5fa47582010-02-09 00:31:33 +0100200 flag sign && opts="$opts -s"
201 [ "$FLAGS_signingkey" != "" ] && opts="$opts -u '$FLAGS_signingkey'"
202 [ "$FLAGS_message" != "" ] && opts="$opts -m '$FLAGS_message'"
203 git tag $opts "$VERSION_PREFIX$VERSION" || \
204 die "Tagging failed. Please run finish again to retry."
205 fi
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100206
Vincent Driessen5fa47582010-02-09 00:31:33 +0100207 # try to merge into develop
208 # in case a previous attempt to finish this release branch has failed,
209 # but the merge into develop was successful, we skip it now
Vincent Driessena4dd2232010-02-10 00:34:59 +0100210 if ! gitflow_is_branch_merged_into "$BRANCH" "$DEVELOP_BRANCH"; then
211 git checkout "$DEVELOP_BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100212 die "Could not check out $DEVELOP_BRANCH."
213
Vincent Driessend29e3152010-02-09 00:55:06 +0100214 # TODO: Actually, accounting for 'git describe' pays, so we should
215 # ideally git merge --no-ff $tagname here, instead!
Vincent Driessena4dd2232010-02-10 00:34:59 +0100216 git merge --no-ff "$BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100217 die "There were merge conflicts."
218 # TODO: What do we do now?
219 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100220
221 # delete branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100222 git branch -d "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100223
Vincent Driessenddba2df2010-02-19 06:42:18 +0100224 if flag push; then
225 git push "$ORIGIN" "$DEVELOP_BRANCH" || \
226 die "Could not push to $DEVELOP_BRANCH from $ORIGIN."
227 git push "$ORIGIN" "$MASTER_BRANCH" || \
228 die "Could not push to $MASTER_BRANCH from $ORIGIN."
229 git push --tags "$ORIGIN" || \
230 die "Could not push tags to $ORIGIN."
231 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100232
233 echo
234 echo "Summary of actions:"
Benedikt Böhm350e7152010-01-26 13:05:05 +0100235 echo "- Latest objects have been fetched from '$ORIGIN'"
Vincent Driessen010252a2010-02-04 10:31:29 +0100236 echo "- Hotfix branch has been merged into '$MASTER_BRANCH'"
Vincent Driessenab3dc492010-01-29 12:35:49 +0100237 echo "- The hotfix was tagged '$VERSION_PREFIX$VERSION'"
Vincent Driessen010252a2010-02-04 10:31:29 +0100238 echo "- Hotfix branch has been back-merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100239 echo "- Hotfix branch '$BRANCH' has been deleted"
Vincent Driessenddba2df2010-02-19 06:42:18 +0100240 if flag push; then
241 echo "- '$DEVELOP_BRANCH', '$MASTER_BRANCH' and tags have been pushed to '$ORIGIN'"
242 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100243 echo
244}